##################################################################################################
######## kol 2.5 - een ##############

#nacteni knihovny pro praci s obrazky
library(imager)
library(pracma)

#nastavime cestu k adresari
setwd("/home/coosa/Documents/SKOMAM/2019/")

#vycistime prostredi
remove(list = ls())
dev.off()

convolution <- function(img, mask){
    mask_x<-dim(mask)[1]
    mask_y<-dim(mask)[2]
    img_x<-dim(img)[1]
    img_y<-dim(img)[2]
    img_conv<-img
    
    w= floor(mask_x/2.0)
    h= floor(mask_y/2.0)
    
    for (i in (w+1):(img_x-w)) {
        for (j in (h+1):(img_y-h)) {
            img_conv[i,j]<-sum(img[(i-w):(i+w),(j-h):(j+h)]*mask)
        }
    }
    if(sum(mask)!=0){
        img_conv = img_conv/sum(mask)
    }
    return(img_conv)
}

#nacteme obrazek
lena<-load.image("lena.png")

#pokud chceme pracovat jen s jasy, prevedeme obrazek do odstinu sedi
gray<-grayscale(lena)
#vyrobime si matici
gray_mat<-as.matrix(gray)

#navolime si nejake masky, ktere pak muzeme pouzit
#gaussova maska
gauss<-matrix(c(0,1,0,1,-4,1,0,1,0),nrow = 3,ncol = 3)
#zvyrazni horizontalni hrany
horizontal<-matrix(c(1,1,1,0,0,0,-1,-1,-1),nrow = 3,ncol = 3)
#zvyrazni vertikalni hrany
vertical<-matrix(c(1,0,-1,1,0,-1,1,0,-1),nrow = 3,ncol = 3)
#rozmaze obrazek (odstrani sum)
noise<-1/9.0 * matrix(c(1,1,1,1,1,1,1,1,1),nrow = 3,ncol = 3)

#provedeme konvoluci
plot(as.cimg(convolution(gray_mat,noise)))
